# Docker Environment for Wt (webtoolkit.eu)

This structure enables the creation of Wt-Programs in a Docker environment
There are several Steps in wich most are automated.

This Document will be updated as the Project evolves.

# Project Structure
-Docker     <- Everything to do with Docker
-Wt-Project <- Your Source Files, approot, docroot
-Wt         <- Wt Config Files, Bootstrap Additions (I use for most Projects)
Readme.md   <- This File 

# Commands

Fast start:
From within the root directory, run for ubuntu based images
```bash
docker build . -f Docker/Wt/ubuntu_19.04/Dockerfile --build-arg wtversion=4.2.0 --build-arg projectname=WtApplication.wt --target application -t wt-docker-hello:latest
docker-compose -f Docker/docker-compose.yml up
```
From within the root directory, run for alpine based images
```bash
docker build . -f Docker/Wt/alpine_3/Dockerfile --build-arg wtversion=4.2.0 --build-arg projectname=WtApplication.wt --target application -t wt-docker-hello:latest
docker-compose -f Docker/docker-compose.yml up
```
Navigate to http://localhost:8080/


## One Dockerfile to rule them all
Currently the Dockerfile can be used by itsself to create a Working Container of a Buildable CMake Project inside of >Wt-Project

It is possible to create seperate Containers in different Steps to be used with different Projects

In Order to work properly, currently there is only one target of CMake supported and the default name for the target is WtApplication.wt 
Default Wt-Version is 4.2.0 and has been tested, change is possible with different git-tags/branches

That can be changed with build-time arguments: 
    --build-arg projectname=<your-app-name-here.wt>
    --build-arg wtversion=<version> e.g.: 4.1.0 

If you want to know the different Steps, look into >Docker/Wt/Dockerfile
It is a multistage-build so any stage can be targeted for building a seperate image.
These can be used in docker-compose so that there is less computation

For reuse I create these images:
    wt-runtime: Clean Ubuntu with Installed dependencies, no dev Packages. --build-arg must be set when != 4.2.0 otherwise it is optional
```bash
``` docker build . -f Docker/Wt/ubuntu_19.04/Dockerfile --build-arg wtversion=4.2.0 --target wt-runtime -t wt-runtime:4.2.0
```
   application: Adding the finished App and resources like docroot and approot to wt-runtime. --build-arg projectname=!!! must be set if not WtApplication.wt!! rename wt-docker-hello in -t with something to reuse in docker-compose! 
```bash
``` docker build . -f Docker/Wt/ubuntu_19.04/Dockerfile --build-arg wtversion=4.2.0 --build-arg projectname=WtApplication.wt --target application -t wt-docker-hello:latest
```

## Compose a Start

Within >Docker/docker-compose.yml the service: app, currently uses the image, that is build with the last command of the previous section.

other services like database or reverse-proxy can be placed here as well


If you do not like to use a previously build image: in the comments, you can change it to let compose handle the build.


### -Docker/Wt-Build/Dockerfile
Here you can change the dependencies for your Wt Installation.
It consists of multiple Steps for the Image creation to make use of docker cache
First Step includes Build essentials
Second Step all other dependencies, namely
    Boost
    OpenSSL
    HaruPDF
    GraphicsMagick
    Pango
    PostgreSQL
    LibZ for Compressing
    OpenGL

Order as Listed in Recommendation from the Wt INSTALL File
Dev libs are installed and release libs are listed in comments next to them.

Some options have not been tested, like mysql/firebird ...

All Necessary Changes to get Wt to Compile should be made in this Step.
This Image will not be used for Running your Wt-Application.





