#include "Application.h"
#include <Wt/WApplication.h>
#include <Wt/WBootstrapTheme.h>
#include <Wt/WContainerWidget.h>
#include <Wt/WText.h>

#include <Wt/Dbo/ptr.h>
#include <Wt/Dbo/Transaction.h>

#include "Landing/widgets/Landing_PlaceHolder.h"





namespace ApplicationNS
{


Application::Application(const Wt::WEnvironment &env)
    : Wt::WApplication(env)
{

    setTitle("LogSplitter");

    container = root()->addWidget(std::make_unique<Wt::WContainerWidget>());

    setupResourceBundles();
    setupStyles();
    createLayout();
    setupConnections();
}

Application::~Application()
{}



/********************************************
 *
 * Private Functions
 *
 * *****************************************/


void Application::setupResourceBundles()
{
    this->messageResourceBundle()
            .use(Wt::WApplication::appRoot() +
                 "Hello/templates/widget_templates");
    this->messageResourceBundle()
            .use(Wt::WApplication::appRoot() +
                 "Hello/language_files/language");



}



void Application::createLayout()
{
   place_Lander = container->addWidget(std::make_unique<Widgets::Landing::Placeholder>());

}


void Application::setupConnections()
{

}


void Application::setupStyles()
{
    std::shared_ptr<Wt::WBootstrapTheme> bs_theme =
            std::make_shared<Wt::WBootstrapTheme>();

    bs_theme->setVersion(Wt::BootstrapVersion::v3);
    bs_theme->setResponsive(true);

    this->setTheme(std::move(bs_theme));

    this->root()->setStyleClass("container");

    this->useStyleSheet("/Hello/styles/style.css");
    this->useStyleSheet("/resources/Bootstrap_addons.css");


}

} // end namespace ApplicationNS
