#include "Landing_PlaceHolder.h"

#include <Wt/WContainerWidget.h>
#include <Wt/WTemplate.h>
#include <Wt/WString.h>
#include <Wt/WLineEdit.h>
#include <Wt/WCheckBox.h>
#include <Wt/WPushButton.h>


namespace ApplicationNS
{
namespace Widgets
{
namespace Landing
{

Placeholder::Placeholder()
{
    createLayout();
    setupConnections();
}

Placeholder::~Placeholder()
{}

void Placeholder::createLayout()
{
    tmpl_Layout = addWidget(std::make_unique<Wt::WTemplate>(
                Wt::WString::tr("template.Widget.Landing.Placeholder")));
    tmpl_Layout->addFunction("tr", &Wt::WTemplate::Functions::tr);
    tmpl_Layout->addFunction("id", &Wt::WTemplate::Functions::id);


    le_input_Name = tmpl_Layout->bindWidget("le_Name", std::make_unique<Wt::WLineEdit>());
   
    btn_Send = tmpl_Layout->bindWidget("btn_Send", std::make_unique<Wt::WPushButton>(
                                           Wt::WString::tr("text.Button.Send")));
    btn_Send->addStyleClass("btn-success");

    txt_greeting = tmpl_Layout->bindWidget("txt_greeting", std::make_unique<Wt::WText>());

    tmpl_Layout->show();


}

void Placeholder::setupConnections()
{
    btn_Send->clicked().connect(this, &Placeholder::con_btn_Send_clicked);
}

void Placeholder::con_btn_Send_clicked()
{
    // Save LineEdit Entries to DB, needs to be Validated TODO
    txt_greeting->setText(Wt::WString("Hello {1}").arg(le_input_Name->text()));
}


}}} // end Namespaces
